/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * Post
 */

public class Post {
  @JsonProperty("content")
  private String content = null;

  @JsonProperty("created_at")
  private LocalDateTime createdAt = null;

  @JsonProperty("credit_to")
  private String creditTo = null;

  @JsonProperty("credit_url")
  private String creditUrl = null;

  @JsonProperty("datasets")
  private List<Dataset> datasets = null;

  @JsonProperty("headline")
  private String headline = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("image")
  private String image = null;

  @JsonProperty("last_modified")
  private LocalDateTime lastModified = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("owner")
  private Object owner = null;

  @JsonProperty("page")
  private String page = null;

  @JsonProperty("published")
  private LocalDateTime published = null;

  @JsonProperty("reuses")
  private List<Reuse> reuses = null;

  @JsonProperty("slug")
  private String slug = null;

  @JsonProperty("tags")
  private List<String> tags = null;

  @JsonProperty("uri")
  private String uri = null;

  public Post content(String content) {
    this.content = content;
    return this;
  }

   /**
   * The post content in Markdown
   * @return content
  **/
  @ApiModelProperty(required = true, value = "The post content in Markdown")
  public String getContent() {
    return content;
  }

  public void setContent(String content) {
    this.content = content;
  }

   /**
   * The post creation date
   * @return createdAt
  **/
  @ApiModelProperty(value = "The post creation date")
  public LocalDateTime getCreatedAt() {
    return createdAt;
  }

  public Post creditTo(String creditTo) {
    this.creditTo = creditTo;
    return this;
  }

   /**
   * An optional credit line (associated to the image)
   * @return creditTo
  **/
  @ApiModelProperty(value = "An optional credit line (associated to the image)")
  public String getCreditTo() {
    return creditTo;
  }

  public void setCreditTo(String creditTo) {
    this.creditTo = creditTo;
  }

  public Post creditUrl(String creditUrl) {
    this.creditUrl = creditUrl;
    return this;
  }

   /**
   * An optional link associated to the credits
   * @return creditUrl
  **/
  @ApiModelProperty(value = "An optional link associated to the credits")
  public String getCreditUrl() {
    return creditUrl;
  }

  public void setCreditUrl(String creditUrl) {
    this.creditUrl = creditUrl;
  }

  public Post datasets(List<Dataset> datasets) {
    this.datasets = datasets;
    return this;
  }

  public Post addDatasetsItem(Dataset datasetsItem) {
    if (this.datasets == null) {
      this.datasets = new ArrayList<Dataset>();
    }
    this.datasets.add(datasetsItem);
    return this;
  }

   /**
   * The post datasets
   * @return datasets
  **/
  @ApiModelProperty(value = "The post datasets")
  public List<Dataset> getDatasets() {
    return datasets;
  }

  public void setDatasets(List<Dataset> datasets) {
    this.datasets = datasets;
  }

  public Post headline(String headline) {
    this.headline = headline;
    return this;
  }

   /**
   * The post headline
   * @return headline
  **/
  @ApiModelProperty(required = true, value = "The post headline")
  public String getHeadline() {
    return headline;
  }

  public void setHeadline(String headline) {
    this.headline = headline;
  }

  public Post id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The post identifier
   * @return id
  **/
  @ApiModelProperty(value = "The post identifier")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

   /**
   * The post image
   * @return image
  **/
  @ApiModelProperty(value = "The post image")
  public String getImage() {
    return image;
  }

   /**
   * The post last modification date
   * @return lastModified
  **/
  @ApiModelProperty(value = "The post last modification date")
  public LocalDateTime getLastModified() {
    return lastModified;
  }

  public Post name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The post name
   * @return name
  **/
  @ApiModelProperty(required = true, value = "The post name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Post owner(Object owner) {
    this.owner = owner;
    return this;
  }

   /**
   * The owner user
   * @return owner
  **/
  @ApiModelProperty(value = "The owner user")
  public Object getOwner() {
    return owner;
  }

  public void setOwner(Object owner) {
    this.owner = owner;
  }

   /**
   * The post page URL
   * @return page
  **/
  @ApiModelProperty(value = "The post page URL")
  public String getPage() {
    return page;
  }

   /**
   * The post publication date
   * @return published
  **/
  @ApiModelProperty(value = "The post publication date")
  public LocalDateTime getPublished() {
    return published;
  }

  public Post reuses(List<Reuse> reuses) {
    this.reuses = reuses;
    return this;
  }

  public Post addReusesItem(Reuse reusesItem) {
    if (this.reuses == null) {
      this.reuses = new ArrayList<Reuse>();
    }
    this.reuses.add(reusesItem);
    return this;
  }

   /**
   * The post reuses
   * @return reuses
  **/
  @ApiModelProperty(value = "The post reuses")
  public List<Reuse> getReuses() {
    return reuses;
  }

  public void setReuses(List<Reuse> reuses) {
    this.reuses = reuses;
  }

   /**
   * The post permalink string
   * @return slug
  **/
  @ApiModelProperty(value = "The post permalink string")
  public String getSlug() {
    return slug;
  }

  public Post tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public Post addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Some keywords to help in search
   * @return tags
  **/
  @ApiModelProperty(value = "Some keywords to help in search")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

   /**
   * The post API URI
   * @return uri
  **/
  @ApiModelProperty(value = "The post API URI")
  public String getUri() {
    return uri;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Post post = (Post) o;
    return Objects.equals(this.content, post.content) &&
        Objects.equals(this.createdAt, post.createdAt) &&
        Objects.equals(this.creditTo, post.creditTo) &&
        Objects.equals(this.creditUrl, post.creditUrl) &&
        Objects.equals(this.datasets, post.datasets) &&
        Objects.equals(this.headline, post.headline) &&
        Objects.equals(this.id, post.id) &&
        Objects.equals(this.image, post.image) &&
        Objects.equals(this.lastModified, post.lastModified) &&
        Objects.equals(this.name, post.name) &&
        Objects.equals(this.owner, post.owner) &&
        Objects.equals(this.page, post.page) &&
        Objects.equals(this.published, post.published) &&
        Objects.equals(this.reuses, post.reuses) &&
        Objects.equals(this.slug, post.slug) &&
        Objects.equals(this.tags, post.tags) &&
        Objects.equals(this.uri, post.uri);
  }

  @Override
  public int hashCode() {
    return Objects.hash(content, createdAt, creditTo, creditUrl, datasets, headline, id, image, lastModified, name, owner, page, published, reuses, slug, tags, uri);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Post {\n");

    sb.append("    content: ").append(toIndentedString(content)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    creditTo: ").append(toIndentedString(creditTo)).append("\n");
    sb.append("    creditUrl: ").append(toIndentedString(creditUrl)).append("\n");
    sb.append("    datasets: ").append(toIndentedString(datasets)).append("\n");
    sb.append("    headline: ").append(toIndentedString(headline)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    image: ").append(toIndentedString(image)).append("\n");
    sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    owner: ").append(toIndentedString(owner)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    published: ").append(toIndentedString(published)).append("\n");
    sb.append("    reuses: ").append(toIndentedString(reuses)).append("\n");
    sb.append("    slug: ").append(toIndentedString(slug)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    uri: ").append(toIndentedString(uri)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

